//+------------------------------------------------------------------+
//|   BetterVolumeTicks.mq4
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1  Red
#property indicator_color2  DarkGray
#property indicator_color3  Yellow
#property indicator_color4  Lime
#property indicator_color5  White
#property indicator_color6  Magenta
#property indicator_color7  Maroon
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  2

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern int    VolPeriod          = 15;
extern int    VolAvgMethod       = MODE_LWMA;
extern int    LookBack           = 7;
extern double volMaxLevel        = 100;
extern double volMinLevel        = 40;
extern string note               = "turn on Alert = true; turn off = false";
extern bool   alertsOn           = true;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = true;
extern bool   alertsEmail        = false;
extern bool   alertsNotify       = false;
extern string soundfile          = "alert2.wav";

//
//
//
//
//

double ClimaxHi[];
double Neutral[];
double LoVolume[];
double Churn[];
double ClimaxLo[];
double ClimaxChurn[];
double AvgVol[];
double UpTicks[];
double DnTicks[];
double VolRange[];
double VolSort[];
double trend[];
string symbol;
int    digits;
double modifier  = 1;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   ArraySetAsSeries(UpTicks,true);
   ArraySetAsSeries(DnTicks,true);
   ArraySetAsSeries(VolRange,true);
   ArraySetAsSeries(VolSort,true);

   IndicatorBuffers(8);
   SetIndexBuffer(0,ClimaxHi);   SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"ClimaxHi");
   SetIndexBuffer(1,Neutral);    SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"Neutral");
   SetIndexBuffer(2,LoVolume);   SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"LoVolume");
   SetIndexBuffer(3,Churn);      SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"Churn");
   SetIndexBuffer(4,ClimaxLo);   SetIndexStyle(4,DRAW_HISTOGRAM); SetIndexLabel(4,"ClimaxLo");
   SetIndexBuffer(5,ClimaxChurn);SetIndexStyle(5,DRAW_HISTOGRAM); SetIndexLabel(5,"ClimaxChurn");
   SetIndexBuffer(6,AvgVol);                                      SetIndexLabel(6,"AvgVolume");
   SetIndexBuffer(7,trend);                                    

   symbol = Symbol(); if (StringSubstr(symbol,0,2)=="_t") symbol = StringSubstr(symbol,2);
   digits = MarketInfo(symbol,MODE_DIGITS);   
	if(digits == 3 || digits == 5) modifier = 10;
	
   IndicatorShortName("BetterVolume Ticks");   
return(0);
}

//
//
//
//
//

int deinit()
{
   
   return(0);
}

//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i = limit; i >= 0; i--)
   {
      ResizeArrays();
      VolSort[i] = Volume[i]/modifier;
      AvgVol[i]  = iMAOnArray(VolSort,0,VolPeriod,0,VolAvgMethod,i);
       trend[i] = trend[i+1];
         if (VolSort[i] > volMaxLevel) trend[i] = 1;
         if (VolSort[i] < volMinLevel) trend[i] =-1; 
   }   

   for(i = limit; i >= 0; i--)
   {
      double Range   = High[i]-Low[i];
      double CountUp = (Volume[i]+(Close[i]-Open[i])/modifier)*0.5;
      double CountDn = Volume[i]-UpTicks[i];

      UpTicks[i] = CountUp*Range;
      DnTicks[i] = CountDn*Range;
      
      if (!CompareDoubles(Range,0)) { VolRange[i] = Volume[i]/Range; }
      
      double LoVol = Volume[iLowest(NULL, 0,MODE_VOLUME,LookBack,i)];
      double HiVol = Volume[iHighest(NULL,0,MODE_VOLUME,LookBack,i)];

      double HiUpTick = UpTicks[FindMaxUp(i)];
      double HiDnTick = DnTicks[FindMaxDn(i)];
      double MaxVol   = VolRange[FindMaxVol(i)];
      
      Neutral[i]     = Volume[i]/modifier;
      ClimaxHi[i]    = EMPTY_VALUE;      
      ClimaxLo[i]    = EMPTY_VALUE;      
      Churn[i]       = EMPTY_VALUE;      
      LoVolume[i]    = EMPTY_VALUE;      
      ClimaxChurn[i] = EMPTY_VALUE;      
      
      if (CompareDoubles(Volume[i],LoVol))
      {
         LoVolume[i] = Volume[i]/modifier;
         Neutral[i]  = EMPTY_VALUE;
      }

      if (CompareDoubles(VolRange[i],MaxVol))
      {
         Churn[i]    = Volume[i]/modifier;                
         Neutral[i]  = EMPTY_VALUE;
         LoVolume[i] = EMPTY_VALUE;
      }

      if (CompareDoubles(UpTicks[i],HiUpTick) && Close[i] >= (High[i]+Low[i])*0.5)
      {
         ClimaxHi[i] = Volume[i]/modifier;
         Neutral[i]  = EMPTY_VALUE;
         LoVolume[i] = EMPTY_VALUE;
         Churn[i]    = EMPTY_VALUE;
      }   
         
      if (CompareDoubles(DnTicks[i],HiDnTick) && Close[i] <= (High[i]+Low[i])*0.5)
      {
         ClimaxLo[i] = Volume[i]/modifier;
         Neutral[i]  = EMPTY_VALUE;
         LoVolume[i] = EMPTY_VALUE;
         Churn[i]    = EMPTY_VALUE;
      }   
         
      if (CompareDoubles(VolRange[i],MaxVol) && (ClimaxHi[i] < EMPTY_VALUE || ClimaxLo[i] < EMPTY_VALUE))
      {
         ClimaxChurn[i] = Volume[i]/modifier;
         ClimaxHi[i]    = EMPTY_VALUE;
         ClimaxLo[i]    = EMPTY_VALUE;
         Churn[i]       = EMPTY_VALUE;
         Neutral[i]     = EMPTY_VALUE;
       }
        
      }
     
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
        if (alertsOnCurrent)
             int whichBar = 0;
        else     whichBar = 1;
        if (trend[whichBar] != trend[whichBar+1])
        if (trend[whichBar] == 1)
              doAlert("High Volume");
        else  doAlert("Low Volume");       
      }
return(0);
}

//
//
//
//
//

int FindMaxUp(int i)      
{
   int x,y;
   double max=0;
   for(x=LookBack-1;x>=0;x--)
   {
      if(UpTicks[i+x] > max)
      {
         y = i+x;
         max = UpTicks[y];
      }
   }
   return(y);
}

//
//
//
//
//

int FindMaxDn(int i)      
{
   int x,y;
   double max=0;
   for(x=LookBack-1;x>=0;x--)
   {
      if(DnTicks[i+x] > max)
      {
         y = i+x;
         max = DnTicks[y];
      }
   }
   return(y);
}

//
//
//
//
//

int FindMaxVol(int i)      
{
   int x,y;
   double max=0;
   for(x=LookBack-1;x>=0;x--)
   {
      if(VolRange[i+x] > max)
      {
         y = i+x;
         max = VolRange[y];
      }
   }
   return(y);
}

//
//
//
//
//

void ResizeArrays()
{
   ArrayResize(UpTicks,Bars);
   ArrayResize(DnTicks,Bars);
   ArrayResize(VolRange,Bars);
   ArrayResize(VolSort,Bars);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Better Volume ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Better Volume "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Better Volume " +" "+message));
             if (alertsSound)   PlaySound(soundfile);
      }
}
      

